=== modified file 'NEWS'
--- NEWS	2010-07-09 15:47:01 +0000
+++ NEWS	2010-07-17 16:36:00 +0000
@@ -5,11 +5,83 @@
 .. contents:: List of Releases
    :depth: 1
 
+bzr 2.2rc1
+##########
+
+:Codename: ???
+:2.2rc1: NOT RELEASED YET
+
+Compatibility Breaks
+********************
+
+* BzrError subclasses no longer support the name "message" to be used
+  as an argument for __init__ or in _fmt format specification as this
+  breaks in some Python versions. errors.LockError.__init__ argument
+  is now named "msg" instead of earlier "message".
+  (Parth Malwankar, #603461)
+
+New Features
+************
+
+Bug Fixes
+*********
+
+* Configuration files in ``${BZR_HOME}`` are now written in an atomic
+  way which should help avoid problems with concurrent writers.
+  (Vincent Ladeuil, #525571)
+
+* Don't traceback trying to unversion children files of an already
+  unversioned directory.  (Vincent Ladeuil, #494221)
+
+* Progress bars prefer to truncate the text message rather than the
+  counters.  The spinner is shown between the network transfer indicator
+  and the progress message.  (Martin Pool)
+
+* Recursive binding for checkouts is now detected by bzr. A clear error
+  message is shown to the user. (Parth Malwankar, #405192)
+
+Improvements
+************
+
+Documentation
+*************
+
+* ``bzr help patterns`` now explains case insensitive patterns and
+  points to Python regular expression documentation.
+  (Parth Malwankar, #594386)
+
+API Changes
+***********
+
+Internals
+*********
+
+Testing
+*******
+
+* Unit test added to ensure that "message" is not uses as a format variable
+  name in BzrError subclasses as this conflicts with some Python versions.
+  (Parth Malwankar, #603461)
+
 bzr 2.2b4
 #########
 
 :Codename: Monkey Magic
-:2.2b4: NOT RELEASED YET
+:2.2b4: 2004-07-09
+
+
+This fourth and final beta in the 2.2 series now stabilizes the internal
+APIs. Plugin authors are recommended to ensure their releases are
+compatible, so that 2.2rc1 can be a true release candidate, containing
+stable and compatible plugin versions. 
+
+For users of bzrlib as a library, one of the primary changes is to request
+that they call ``bzrlib.initialize`` and use the returned context manager
+appropriately.
+
+Better interaction with ``bzr-loom`` to make sure branching from a loom
+even over a smart server still yields a local loom. Not to mention lots of
+bugfixes over 2.2b3.
 
 Compatibility Breaks
 ********************
@@ -21,11 +93,6 @@
   exiting the program, and it made sense to provide a full context
   manager at the same time. (Robert Collins)
 
-* ``bzrlib.re_compile_checked`` is now deprecated. Caller should handle
-  ``bzrlib.errors.InvalidPattern`` exception thrown by ``re.match`` in
-  case the default error message not suitable for the use case.
-  (Parth Malwankar)
-
 * The ``bzr`` front end now requires a ``bzrlib.ui.ui_factory`` which is a
   context manager in the Python 2.5 and above sense. The bzrlib base class
   is such a manager, but third party UI factories which do not derive from
@@ -96,10 +163,6 @@
   ``InvalidPattern`` exception showing clear error message to the user.
   (Parth Malwankar #300062)
 
-* Progress bars prefer to truncate the text message rather than the
-  counters.  The spinner is shown between the network transfer indicator
-  and the progress message.  (Martin Pool)
-
 * Progress output is cleaned up when exiting.  (Aaron Bentley)
 
 * Raise ValueError instead of a string exception.
@@ -188,6 +251,11 @@
   2007, has been deleted.  Use ``PatienceSequenceMatcher`` from
   ``bzrlib.patiencediff`` instead. (Andrew Bennetts)
 
+* ``bzrlib.re_compile_checked`` is now deprecated. Caller should handle
+  ``bzrlib.errors.InvalidPattern`` exception thrown by ``re.match`` in
+  case the default error message not suitable for the use case.
+  (Parth Malwankar)
+
 * ``bzrlib.tests.blackbox.ExternalBase`` is deprecated.  It provided only
   one method ``check_output``, and we now recommend checking command
   output using ``run_script``. (Martin Pool)
@@ -947,6 +1015,13 @@
 Bug Fixes
 *********
 
+* Configuration files in ``${BZR_HOME}`` are now written in an atomic
+  way which should help avoid problems with concurrent writers.
+  (Vincent Ladeuil, #525571)
+
+* Don't traceback trying to unversion children files of an already
+  unversioned directory.  (Vincent Ladeuil, #494221)
+
 * Raise ValueError instead of a string exception.
   (John Arbash Meinel, #586926)
 
@@ -1460,6 +1535,9 @@
   permissions as ``.bzr`` directory on a POSIX OS.
   (Parth Malwankar, #262450)
 
+* Don't traceback trying to unversion children files of an already
+  unversioned directory.  (Vincent Ladeuil, #494221)
+
 * Raise ValueError instead of a string exception.
   (John Arbash Meinel, #586926)
 

=== modified file 'bzrlib/__init__.py'
--- bzrlib/__init__.py	2010-07-02 22:44:00 +0000
+++ bzrlib/__init__.py	2010-07-09 21:02:54 +0000
@@ -52,7 +52,7 @@
 # Python version 2.0 is (2, 0, 0, 'final', 0)."  Additionally we use a
 # releaselevel of 'dev' for unreleased under-development code.
 
-version_info = (2, 2, 0, 'beta', 3)
+version_info = (2, 2, 0, 'beta', 4)
 
 # API compatibility version
 api_minimum_version = (2, 2, 0)

=== modified file 'bzrlib/branch.py'
--- bzrlib/branch.py	2010-06-30 08:34:11 +0000
+++ bzrlib/branch.py	2010-07-14 08:53:58 +0000
@@ -246,9 +246,13 @@
         if not local and not config.has_explicit_nickname():
             try:
                 master = self.get_master_branch(possible_transports)
+                if master and self.user_url == master.user_url:
+                    raise errors.RecursiveBind(self.user_url)
                 if master is not None:
                     # return the master branch value
                     return master.nick
+            except errors.RecursiveBind, e:
+                raise e
             except errors.BzrError, e:
                 # Silently fall back to local implicit nick if the master is
                 # unavailable

=== modified file 'bzrlib/config.py'
--- bzrlib/config.py	2010-06-02 04:50:35 +0000
+++ bzrlib/config.py	2010-07-13 16:10:20 +0000
@@ -74,6 +74,7 @@
 
 import bzrlib
 from bzrlib import (
+    atomicfile,
     debug,
     errors,
     mail_client,
@@ -478,12 +479,10 @@
         return self.get_user_option('nickname')
 
     def _write_config_file(self):
-        f = file(self._get_filename(), "wb")
-        try:
-            osutils.copy_ownership_from_path(f.name)
-            self._get_parser().write(f)
-        finally:
-            f.close()
+        atomic_file = atomicfile.AtomicFile(self._get_filename())
+        self._get_parser().write(atomic_file)
+        atomic_file.commit()
+        atomic_file.close()
 
 
 class GlobalConfig(IniBasedConfig):

=== modified file 'bzrlib/errors.py'
--- bzrlib/errors.py	2010-06-30 12:03:30 +0000
+++ bzrlib/errors.py	2010-07-14 14:22:40 +0000
@@ -947,11 +947,8 @@
     # original exception is available as e.original_error
     #
     # New code should prefer to raise specific subclasses
-    def __init__(self, message):
-        # Python 2.5 uses a slot for StandardError.message,
-        # so use a different variable name.  We now work around this in
-        # BzrError.__str__, but this member name is kept for compatability.
-        self.msg = message
+    def __init__(self, msg):
+        self.msg = msg
 
 
 class LockActive(LockError):
@@ -1378,12 +1375,12 @@
 
 class WeaveParentMismatch(WeaveError):
 
-    _fmt = "Parents are mismatched between two revisions. %(message)s"
+    _fmt = "Parents are mismatched between two revisions. %(msg)s"
 
 
 class WeaveInvalidChecksum(WeaveError):
 
-    _fmt = "Text did not match it's checksum: %(message)s"
+    _fmt = "Text did not match it's checksum: %(msg)s"
 
 
 class WeaveTextDiffers(WeaveError):
@@ -1437,7 +1434,7 @@
 
 class VersionedFileInvalidChecksum(VersionedFileError):
 
-    _fmt = "Text did not match its checksum: %(message)s"
+    _fmt = "Text did not match its checksum: %(msg)s"
 
 
 class KnitError(InternalBzrError):
@@ -3149,16 +3146,27 @@
     def __init__(self, bzrdir):
         self.bzrdir = bzrdir
 
+
 class NoWhoami(BzrError):
 
     _fmt = ('Unable to determine your name.\n'
         "Please, set your name with the 'whoami' command.\n"
         'E.g. bzr whoami "Your Name <name@example.com>"')
 
+
 class InvalidPattern(BzrError):
 
-    _fmt = ('Invalid pattern(s) found. %(message)s')
-
-    def __init__(self, message):
-        self.message = message
+    _fmt = ('Invalid pattern(s) found. %(msg)s')
+
+    def __init__(self, msg):
+        self.msg = msg
+
+
+class RecursiveBind(BzrError):
+
+    _fmt = ('Branch "%(branch_url)s" appears to be bound to itself. '
+        'Please use `bzr unbind` to fix.')
+
+    def __init__(self, branch_url):
+        self.branch_url = branch_url
 

=== modified file 'bzrlib/globbing.py'
--- bzrlib/globbing.py	2010-07-08 05:11:16 +0000
+++ bzrlib/globbing.py	2010-07-09 16:16:11 +0000
@@ -217,11 +217,11 @@
                 if match:
                     return patterns[match.lastindex -1]
         except errors.InvalidPattern, e:
-            # We can't show the default e.message to the user as thats for
+            # We can't show the default e.msg to the user as thats for
             # the combined pattern we sent to regex. Instead we indicate to
             # the user that an ignore file needs fixing.
-            mutter('Invalid pattern found in regex: %s.', e.message)
-            e.message = "File ~/.bazaar/ignore or .bzrignore contains errors."
+            mutter('Invalid pattern found in regex: %s.', e.msg)
+            e.msg = "File ~/.bazaar/ignore or .bzrignore contains errors."
             raise e
         return None
 

=== modified file 'bzrlib/help_topics/en/patterns.txt'
--- bzrlib/help_topics/en/patterns.txt	2010-01-02 07:36:36 +0000
+++ bzrlib/help_topics/en/patterns.txt	2010-07-16 12:51:21 +0000
@@ -10,7 +10,7 @@
 slash or is a regular expression, it is compared to the whole path
 from the branch root. Otherwise, it is compared to only the last
 component of the path. To match a file only in the root directory,
-prepend './'. Patterns specifying absolute paths are not allowed.
+prepend ``./``. Patterns specifying absolute paths are not allowed.
 
 Patterns may include globbing wildcards such as::
 
@@ -19,10 +19,20 @@
   /**/ - Matches 0 or more directories in a path
   [a-z] - Matches a single character from within a group of characters
 
-Patterns may also be Python regular expressions. Regular expression
-patterns are identified by a 'RE:' prefix followed by the regular
+Patterns may also be `Python regular expressions`_. Regular expression
+patterns are identified by a ``RE:`` prefix followed by the regular
 expression.  Regular expression patterns may not include named or
 numbered groups.
 
-Ignore patterns may be prefixed with '!', which means that a filename
+Case insensitive ignore patterns can be specified with regular expressions
+by using the ``i`` (for ignore case) flag in the pattern.
+
+For example, a case insensitive match for ``foo`` may be specified as::
+
+  RE:(?i)foo
+
+Ignore patterns may be prefixed with ``!``, which means that a filename
 matched by that pattern will not be ignored.
+
+.. _Python regular expressions: http://docs.python.org/library/re.html
+

=== modified file 'bzrlib/osutils.py'
--- bzrlib/osutils.py	2010-07-08 10:34:12 +0000
+++ bzrlib/osutils.py	2010-07-09 16:16:11 +0000
@@ -2184,7 +2184,7 @@
             where = ' in ' + where
         # despite the name 'error' is a type
         raise errors.BzrCommandError('Invalid regular expression%s: %s'
-            % (where, e.message))
+            % (where, e.msg))
 
 
 if sys.platform == "win32":

=== modified file 'bzrlib/tests/blackbox/test_commit.py'
--- bzrlib/tests/blackbox/test_commit.py	2010-06-28 02:41:22 +0000
+++ bzrlib/tests/blackbox/test_commit.py	2010-07-14 08:53:58 +0000
@@ -22,6 +22,7 @@
 import sys
 
 from bzrlib import (
+    bzrdir,
     osutils,
     ignores,
     msgeditor,
@@ -757,3 +758,18 @@
         osutils.set_or_unset_env('BZR_EMAIL', None)
         out, err = self.run_bzr(['commit', '-m', 'initial'], 3)
         self.assertContainsRe(err, 'Unable to determine your name')
+
+    def test_commit_recursive_checkout(self):
+        """Ensure that a commit to a recursive checkout fails cleanly.
+        """
+        self.run_bzr(['init', 'test_branch'])
+        self.run_bzr(['checkout', 'test_branch', 'test_checkout'])
+        os.chdir('test_checkout')
+        self.run_bzr(['bind', '.']) # bind to self
+        open('foo.txt', 'w').write('hello')
+        self.run_bzr(['add'])
+        out, err = self.run_bzr(['commit', '-m', 'addedfoo'], 3)
+        self.assertEqual(out, '')
+        self.assertContainsRe(err,
+            'Branch.*test_checkout.*appears to be bound to itself')
+

=== modified file 'bzrlib/tests/blackbox/test_log.py'
--- bzrlib/tests/blackbox/test_log.py	2010-06-30 12:03:30 +0000
+++ bzrlib/tests/blackbox/test_log.py	2010-07-09 16:16:11 +0000
@@ -387,6 +387,7 @@
         self.make_minimal_branch()
         out, err = self.run_bzr(['log', '-m', '*'], retcode=3)
         self.assertContainsRe(err, "ERROR.*Invalid pattern.*nothing to repeat")
+        self.assertNotContainsRe(err, "Unprintable exception")
         self.assertEqual(out, '')
 
     def test_log_unsupported_timezone(self):

=== modified file 'bzrlib/tests/test_errors.py'
--- bzrlib/tests/test_errors.py	2010-05-20 18:23:17 +0000
+++ bzrlib/tests/test_errors.py	2010-07-14 14:22:40 +0000
@@ -16,6 +16,8 @@
 
 """Tests for the formatting and construction of errors."""
 
+import inspect
+import re
 import socket
 import sys
 
@@ -26,11 +28,36 @@
     symbol_versioning,
     urlutils,
     )
-from bzrlib.tests import TestCase, TestCaseWithTransport
+from bzrlib.tests import TestCase, TestCaseWithTransport, TestSkipped
 
 
 class TestErrors(TestCaseWithTransport):
 
+    def test_no_arg_named_message(self):
+        """Ensure the __init__ and _fmt in errors do not have "message" arg.
+
+        This test fails if __init__ or _fmt in errors has an argument
+        named "message" as this can cause errors in some Python versions.
+        Python 2.5 uses a slot for StandardError.message.
+        See bug #603461
+        """
+        fmt_pattern = re.compile("%\(message\)[sir]")
+        subclasses_present = getattr(errors.BzrError, '__subclasses__', None)
+        if not subclasses_present:
+            raise TestSkipped('__subclasses__ attribute required for classes. '
+                'Requires Python 2.5 or later.')
+        for c in errors.BzrError.__subclasses__():
+            init = getattr(c, '__init__', None)
+            fmt = getattr(c, '_fmt', None)
+            if init:
+                args = inspect.getargspec(init)[0]
+                self.assertFalse('message' in args,
+                    ('Argument name "message" not allowed for '
+                    '"errors.%s.__init__"' % c.__name__))
+            if fmt and fmt_pattern.search(fmt):
+                self.assertFalse(True, ('"message" not allowed in '
+                    '"errors.%s._fmt"' % c.__name__))
+
     def test_bad_filename_encoding(self):
         error = errors.BadFilenameEncoding('bad/filen\xe5me', 'UTF-8')
         self.assertEqualDiff(
@@ -655,6 +682,17 @@
         str(err)
         self.assertEqual(['open_repository'], fake_bzrdir.calls)
 
+    def test_invalid_pattern(self):
+        error = errors.InvalidPattern('Bad pattern msg.')
+        self.assertEqualDiff("Invalid pattern(s) found. Bad pattern msg.",
+            str(error))
+
+    def test_recursive_bind(self):
+        error = errors.RecursiveBind('foo_bar_branch')
+        msg = ('Branch "foo_bar_branch" appears to be bound to itself. '
+            'Please use `bzr unbind` to fix.')
+        self.assertEqualDiff(msg, str(error))
+
 
 class PassThroughError(errors.BzrError):
 

=== modified file 'bzrlib/tests/test_globbing.py'
--- bzrlib/tests/test_globbing.py	2010-06-30 13:49:02 +0000
+++ bzrlib/tests/test_globbing.py	2010-07-09 16:16:11 +0000
@@ -314,7 +314,7 @@
         patterns = [u'RE:[']
         g = Globster(patterns)
         e = self.assertRaises(errors.InvalidPattern, g.match, 'foo')
-        self.assertContainsRe(e.message, "File.*ignore.*contains errors")
+        self.assertContainsRe(e.msg, "File.*ignore.*contains errors")
 
 
 class TestExceptionGlobster(TestCase):

=== modified file 'bzrlib/tests/test_lazy_regex.py'
--- bzrlib/tests/test_lazy_regex.py	2010-06-30 13:49:02 +0000
+++ bzrlib/tests/test_lazy_regex.py	2010-07-09 16:16:11 +0000
@@ -70,8 +70,7 @@
         # As p.match is lazy, we make it into a lambda so its handled
         # by assertRaises correctly.
         e = self.assertRaises(errors.InvalidPattern, lambda: p.match('foo'))
-        self.assertEqual(e.message,
-            '"RE:[" unexpected end of regular expression')
+        self.assertEqual(e.msg, '"RE:[" unexpected end of regular expression')
 
 
 class TestLazyCompile(tests.TestCase):

=== modified file 'bzrlib/tests/test_workingtree_4.py'
--- bzrlib/tests/test_workingtree_4.py	2010-02-04 16:06:36 +0000
+++ bzrlib/tests/test_workingtree_4.py	2010-07-13 16:10:20 +0000
@@ -757,3 +757,23 @@
             ('', [(('', 'dir', 'dir-id'), ['d', 'd'])]),
             ('dir', [(('dir', 'file', 'file-id'), ['a', 'f'])]),
         ],  self.get_simple_dirblocks(state))
+
+
+class TestInventoryCoherency(TestCaseWithTransport):
+
+    def test_inventory_is_synced_when_unversioning_a_dir(self):
+        """Unversioning the root of a subtree unversions the entire subtree."""
+        tree = self.make_branch_and_tree('.')
+        self.build_tree(['a/', 'a/b', 'c/'])
+        tree.add(['a', 'a/b', 'c'], ['a-id', 'b-id', 'c-id'])
+        # within a lock unversion should take effect
+        tree.lock_write()
+        self.addCleanup(tree.unlock)
+        # Force access to the in memory inventory to trigger bug #494221: try
+        # maintaining the in-memory inventory
+        inv = tree.inventory
+        self.assertTrue(inv.has_id('a-id'))
+        self.assertTrue(inv.has_id('b-id'))
+        tree.unversion(['a-id', 'b-id'])
+        self.assertFalse(inv.has_id('a-id'))
+        self.assertFalse(inv.has_id('b-id'))

=== modified file 'bzrlib/workingtree_4.py'
--- bzrlib/workingtree_4.py	2010-05-20 18:23:17 +0000
+++ bzrlib/workingtree_4.py	2010-07-13 16:10:20 +0000
@@ -1247,7 +1247,8 @@
         # have to change the legacy inventory too.
         if self._inventory is not None:
             for file_id in file_ids:
-                self._inventory.remove_recursive_id(file_id)
+                if self._inventory.has_id(file_id):
+                    self._inventory.remove_recursive_id(file_id)
 
     @needs_tree_write_lock
     def rename_one(self, from_rel, to_rel, after=False):

